﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.IO;
using ProtocoloSeguroERapidinho;

namespace Cliente
{
    public class ClienteUpload
    {
        public double arrayRttUpload;
        public int contador;
        String arquivo;
        String ip;
        String diretorio;
        double[] arrayTempo;
        double[] arrayRtt;
        int tamanhototal;
        double taxaDeTrasmissao;

        public int getQuantidadeDePacotes()
        {
            int retorno = tamanhototal / 1000;
            if (tamanhototal % 1000 != 0) retorno++;
            return retorno;
            
        }

        public double [] getArrayTempo()
        {
            return this.arrayTempo;
        }


        public ClienteUpload(String nomeDoArquivo, String ipDaGui, String diretorioTodoDoArquivo)
        {
            arquivo = nomeDoArquivo;
            this.ip = ipDaGui;
            this.diretorio = diretorioTodoDoArquivo;
        }

        public void Conectar()
        {
            int cabecalho = 12;

            byte[] data = new byte[cabecalho];

            #region Referencia do servidor
            IPEndPoint ip = new IPEndPoint(IPAddress.Parse("192.168.176.1"), 9999); //IPAddress.Parse("172.17.68.20")

            Socket server = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);

            //   IPEndPoint sender = new IPEndPoint(IPAddress.Any, 0);
            EndPoint Remote = (EndPoint)ip;
            #endregion

            #region relativo ao arquivo

            //Console.WriteLine("Digite alguma merda...:"); //no lugar dessa merda vai vir um pacote dizendo o tamanho dos dados
            //string welcome = Console.ReadLine();
            //int tamanho = int.Parse(welcome);

            #endregion
            //data = Encoding.ASCII.GetBytes(welcome);
            int receivedDataLength;
            byte[] corpoPacoteDownload = new byte[0];
            byte[] checkSuuuum = new byte[2];
            checkSuuuum[0] = (byte)8;
            checkSuuuum[1] = (byte)1;

            #region Pega o arquivo
            // Abre o arquivo C:\SeuArquivo.txt para leitura
            BinaryReader arquivo = new BinaryReader(new FileStream(this.diretorio, FileMode.Open));
            //BinaryReader arquivo = new BinaryReader(new FileStream(@"H:\Com cores.txt", FileMode.Open));
            String temp = this.arquivo;
            //String temp = "edim.rar";
            int tamanhoDaString = temp.Length;
            tamanhototal = (int)arquivo.BaseStream.Length;


            #endregion

            byte[] tamanhoLista = new byte[4 + 4 + 4 + tamanhoDaString];

            //Primeiro vamos mandar o tamanho da descricao do pacote...
            #region SETANDO A DESCRICAO

            byte[] tamanhoDaListaIgualAUm = Util.MetodosEmGeral.GetBytes(1);
            byte[] tamanhoDaStringEmBytes = Util.MetodosEmGeral.GetBytes(tamanhoDaString);
            byte[] stringEmBytes = Util.MetodosEmGeral.GetBytes(temp);
            byte[] dadosEmBytes = Util.MetodosEmGeral.GetBytes(tamanhototal);
            int addArray = 0;
            tamanhoDaListaIgualAUm.CopyTo(tamanhoLista, addArray);
            addArray = addArray + tamanhoDaListaIgualAUm.Length;
            tamanhoDaStringEmBytes.CopyTo(tamanhoLista, addArray);
            addArray = addArray + tamanhoDaStringEmBytes.Length;
            stringEmBytes.CopyTo(tamanhoLista, addArray);
            addArray = addArray + stringEmBytes.Length;
            dadosEmBytes.CopyTo(tamanhoLista, addArray);


            byte[] tamanhoDaDescricaoEmBytes = Util.MetodosEmGeral.GetBytes(tamanhoLista.Length);

            #endregion

            #region CRIANDO E ENVIADO PACOTE DO TAMANHO DA DESCRICAO

            PSR pacotePrimeiro = new PSR(1, 2, 0, 0, 8, checkSuuuum, corpoPacoteDownload);
            server.SendTo(pacotePrimeiro.Pacotao, pacotePrimeiro.Pacotao.Length, SocketFlags.None, ip); //manda requisicao de conexao

            //Comeca aqui...
            PSR tamanhoDaDescricao = new PSR(1, 1, 1, 1, 9, checkSuuuum, tamanhoDaDescricaoEmBytes);
            DateTime inicio = DateTime.Now;
            server.SendTo(tamanhoDaDescricao.Pacotao, tamanhoDaDescricao.Pacotao.Length, SocketFlags.None, ip);

            #endregion

            //Receber um ack...
            #region RECEBENDO UM ACKZIM

            data = new byte[cabecalho];
            receivedDataLength = server.ReceiveFrom(data, ref Remote);
            DateTime fim = DateTime.Now;
            TimeSpan Rtt = fim.Subtract(inicio);
            double rtt1 = Rtt.TotalMilliseconds;

            if(rtt1 == 0)
            {
                rtt1=1;
            }
            double tempo1 = tamanhoDaDescricao.Pacotao.Length / rtt1;
            PSR pacotimAck = new PSR(data);

            #endregion

            //Mandando agora a descricao
            #region DESCRICAO

            PSR pacotimDescricao = new PSR(1, 1, 1, 1, 0, checkSuuuum, tamanhoLista);
            inicio = DateTime.Now;
            server.SendTo(pacotimDescricao.Pacotao, pacotimDescricao.Pacotao.Length, SocketFlags.None, ip);

            #endregion

            //Receber um ack...
            #region RECEBENDO UM ACKZIM

            data = new byte[cabecalho];
            receivedDataLength = server.ReceiveFrom(data, ref Remote);
            fim = DateTime.Now;
            Rtt = fim.Subtract(inicio);
            double rtt2 = Rtt.TotalMilliseconds;
            if(rtt2 == 0)
            {
                rtt2=1;
            }
            double tempo2 = pacotimDescricao.Pacotao.Length / rtt2;
            pacotimAck = new PSR(data);

            #endregion

            //A PARTIR DAQUI EH PARA MANDAR O ARQUIVO...

            #region MANDAR O ARQUIVOOOOO...
            data = new byte[cabecalho]; //realoco espaço pra data

            //int indice = 0;
            contador = 0;
            int bytesEnviado = 1000;
            PSR pacotinhoCorpo;
            int recebe_ack = 0;
            byte[] baiteZero = new byte[0];
            byte[] ack;

            int numeroPacotes = tamanhototal / 1000;
            if (tamanhototal % 1000 != 0) numeroPacotes++;
            arrayTempo = new double[numeroPacotes + 2];
            arrayRtt = new double[numeroPacotes + 2];
            arrayRtt[0] = rtt1;
            arrayRtt[1] = rtt2;
            arrayTempo[0] = tempo1;
            arrayTempo[1] = tempo2;
            double rtt_da_vez;
            int indiceTempo = 2;
            while (tamanhototal > bytesEnviado * contador)
            {
                if (tamanhototal > bytesEnviado * (contador + 1)) //entra aki se nao for o ultimo pacote
                {
                    data = null;
                    data = new byte[bytesEnviado];
                    arquivo.BaseStream.Read(data, 0, bytesEnviado); //data recebe a parte da vez de arquivo, e baseStream.Read faz isso automaticamente
                    pacotinhoCorpo = new PSR(1, 1, 1, 1, 1, checkSuuuum, data);

                    inicio = DateTime.Now;
                    server.SendTo(pacotinhoCorpo.Pacotao, pacotinhoCorpo.Pacotao.Length, SocketFlags.None, Remote);//envia o pacote na rede
                    ack = new byte[cabecalho];

                    recebe_ack = server.ReceiveFrom(ack, ref Remote); //so recebe o ack
                    fim = DateTime.Now;
                    Rtt = fim.Subtract(inicio);
                    rtt_da_vez = Rtt.TotalMilliseconds;
                    if (rtt_da_vez == 0)
                    {
                        rtt_da_vez = 1;
                    }
                    arrayTempo[indiceTempo] = pacotinhoCorpo.Pacotao.Length / rtt_da_vez;
                    indiceTempo++;
                }

                else  //o tamanho do ultimo pacote pode ser menor q cada_pacote
                {
                    int remainLen = tamanhototal - bytesEnviado * contador;
                    data = null;
                    data = new byte[remainLen];
                    arquivo.BaseStream.Read(data, 0, remainLen);
                    pacotinhoCorpo = new PSR(1, 1, 1, 1, 1, checkSuuuum, data);

                    inicio = DateTime.Now;
                    server.SendTo(pacotinhoCorpo.Pacotao, pacotinhoCorpo.Pacotao.Length, SocketFlags.None, Remote);//envia o pacote na rede
                    ack = new byte[cabecalho];

                    recebe_ack = server.ReceiveFrom(ack, ref Remote); //so recebe o ack
                    fim = DateTime.Now;
                    Rtt = fim.Subtract(inicio);
                    rtt_da_vez = Rtt.TotalMilliseconds;
                    if (rtt_da_vez == 0)
                    {
                        rtt_da_vez = 1;
                    }
                    arrayTempo[indiceTempo] = pacotinhoCorpo.Pacotao.Length / rtt_da_vez;
                    indiceTempo++;
                }

                arrayRtt[contador + 2] = rtt_da_vez;
                contador++;
                
            }

            pacotinhoCorpo = new PSR(1, 1, 1, 1, 10, checkSuuuum, baiteZero);
            server.SendTo(pacotinhoCorpo.Pacotao, pacotinhoCorpo.Pacotao.Length, SocketFlags.None, Remote);//envia o pacote na rede

            #endregion

            server.Close();
        }

        public static void Main() { }

    }
}