﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.IO;
using ProtocoloSeguroERapidinho;

namespace Servidor
{
    public class ServidorUpload
    {
        //IPEndPoint ip;
        Socket socket;
        IPEndPoint sender;
        EndPoint Remote;
        int tamanhoTotal;
        public ServidorUpload(Socket socket1,IPEndPoint sender1, EndPoint remote)
        {
            
            this.socket = socket1;
            this.sender = sender1;
            Remote = (EndPoint)remote;

        }

        public void Enviar()
        {

            int cabecalho = 12;  ///FALTA SUSTITUIR 12 POR CABECALHO
            int cada_pacote = 1000;
            int receivedDataLength;
            byte[] ack = new byte[cabecalho];
            byte[] data = new byte[cabecalho + 4];    //o tamanho do pacote eh cabecalho + 4 inicialmente... para poder receber o tamanho da descricao... x)
            int contador = 0;
            byte[] checkSuuuuum = new byte[2];
            checkSuuuuum[0] = (byte)2;
            checkSuuuuum[1] = (byte)1;
            byte[] baiteZero = new byte[0];

            #region Referencia do cliente
            //IPEndPoint ip = new IPEndPoint(IPAddress.Any, 9999);

            //Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);

            //socket.Bind(ip);

            //IPEndPoint sender = new IPEndPoint(IPAddress.Any, 0);
            //EndPoint Remote = (EndPoint)(ip);
            #endregion

            PSR pacotinhoAck = new PSR(1, 1, 1, 1, 5, checkSuuuuum, baiteZero);
            bool podeParar = false;
            #region Loop do Servidor
            while (!podeParar) //esse loop mantem o servidor de pé
            {
                #region RECEBENDO O TAMANHO DA DESCRICAO

                receivedDataLength = socket.ReceiveFrom(data, ref Remote);  // RECEBE O TAMANHO DA DESCRICAO...ONLY THIS POTATO...
                PSR pacotinhoTamanhoDaDescricao = new PSR(data);
 
                #endregion

                #region Mandando um ackzim...

                pacotinhoAck = new PSR(1, 1, 1, 1, 5, checkSuuuuum, baiteZero);
                socket.SendTo(pacotinhoAck.Pacotao, pacotinhoAck.Pacotao.Length, SocketFlags.None, Remote);//envia o pacote na rede

                #endregion

                #region RECEBENDO A DESCRICAO...
                
                int tamanhoDaDescricao = pacotinhoTamanhoDaDescricao.TamanhoTipo9;
                data = new byte[tamanhoDaDescricao + cabecalho];
                receivedDataLength = socket.ReceiveFrom(data, ref Remote);  // RECEBE O TAMANHO DA DESCRICAO...ONLY THIS POTATO...
                PSR pacotinhoDescricao = new PSR(data);
                
                

                #endregion

                #region Mandando um ackzim...

                pacotinhoAck = new PSR(1, 1, 1, 1, 5, checkSuuuuum, baiteZero);
                socket.SendTo(pacotinhoAck.Pacotao, pacotinhoAck.Pacotao.Length, SocketFlags.None, Remote);//envia o pacote na rede

                #endregion

                tamanhoTotal = pacotinhoDescricao.TamanhoDeCadaArquivo[0];
                byte[] arrayBytesDoArquivo = new byte[tamanhoTotal];


                #region RECEBENDO O ARQUIVO...

                PSR pacotinhoCorpo;
                int indice = 0;
                while (tamanhoTotal > cada_pacote * contador)
                {
                    if (tamanhoTotal > cada_pacote * (contador + 1)) //entra aki se nao for o ultimo pacote
                    {
                        data = null;
                        data = new byte[cada_pacote + cabecalho];
                        receivedDataLength = socket.ReceiveFrom(data, ref Remote); //so recebe o ack
                        pacotinhoCorpo = new PSR(data);
                        pacotinhoCorpo.Dados.CopyTo(arrayBytesDoArquivo, indice);
                        indice = indice + cada_pacote;
                        #region Mandando um ackzim...
                        pacotinhoAck = new PSR(1, 1, 1, 1, 5, checkSuuuuum, baiteZero);
                        socket.SendTo(pacotinhoAck.Pacotao, pacotinhoAck.Pacotao.Length, SocketFlags.None, Remote);//envia o pacote na rede

                        #endregion

                    }
                    else  //o tamanho do ultimo pacote pode ser menor q cada_pacote
                    {
                        int remainLen = tamanhoTotal - cada_pacote * contador;
                        data = null;
                        data = new byte[remainLen + cabecalho];
                        receivedDataLength = socket.ReceiveFrom(data, ref Remote); //so recebe o ack
                        pacotinhoCorpo = new PSR(data);

                        pacotinhoCorpo.Dados.CopyTo(arrayBytesDoArquivo, indice);
                        indice = indice + remainLen;

                        #region Mandando um ackzim...

                        pacotinhoAck = new PSR(1, 1, 1, 1, 5, checkSuuuuum, baiteZero);
                        socket.SendTo(pacotinhoAck.Pacotao, pacotinhoAck.Pacotao.Length, SocketFlags.None, Remote);//envia o pacote na rede

                        #endregion
                    }
                    contador++;
                }
 
                #endregion
                //File.WriteAllBytes(@"H:\AreaDeTransferencia\" + pacotinhoDescricao.NomeDoArquivo[0] , arrayBytesDoArquivo);
                File.WriteAllBytes(@"D:\AreaDeTransferencia\" + pacotinhoDescricao.NomeDoArquivo[0] , arrayBytesDoArquivo);
                podeParar = true;
            }
            #endregion
        }
        public static void Main() { }
    }
}
