﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Util
{
    
    public static class MetodosEmGeral
    {
       

        #region Conversoes

        public static int GetInt(byte[] array)
        {
            return BitConverter.ToInt32(array, 0);
        }

        public static int GetInt(byte b)
        {
            return (int)b;
        }

        public static string GetString(byte[] array)
        {
            byte[] dBytes = array; // seu array de bytes. 
            string str; // String que irá receber a conversão
            System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
            str = enc.GetString(dBytes);
            return str;
        }

        public static byte GetByte(int numero)
        {
            return (byte)numero;
        }

        public static byte[] GetBytes(int numero)
        {
            return BitConverter.GetBytes(numero);
        }

        public static byte[] GetBytes(string nome)
        {
            return Encoding.ASCII.GetBytes(nome);
        }

        #endregion

        public static double RttEstimado(double media_antiga, double amostra_atual)
        {
            double estimadeRTT = 0;
            if (media_antiga == 0)
            {
                estimadeRTT = amostra_atual;
            }
            else
            {
                estimadeRTT = (0.875 * media_antiga) + (0.125 * amostra_atual);
            }
            return estimadeRTT;
        }

        public static double TempoParaAcabar(int tamanho_total, int recebido,
            int tamanho_cada_pacote, double tempo_estimado)
        {
            double tempo_restante = 0;

            tempo_restante = ((tamanho_total - recebido) / tamanho_cada_pacote) * tempo_estimado;

            return tempo_restante;
        }
    }
   
        
        
        

        
            
}
    

