﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.IO;
using ProtocoloSeguroERapidinho;

namespace Cliente
{
    public class DownClient
    {
        int tamanho;
        public DownClient()
        {

        }

        public static double RttEstimado(double media_antiga, double amostra_atual)
        {
            double estimadeRTT = 0;
            if (media_antiga == 0)
            {
                estimadeRTT = amostra_atual;
            }
            else
            {
                estimadeRTT = (0.875 * media_antiga) + (0.125 * amostra_atual);
            }
            return estimadeRTT;
        }

        public static double TempoParaAcabar(int tamanho_total, int recebido,
            int tamanho_cada_pacote, double tempo_estimado)
        {
            double tempo_restante = 0;

            tempo_restante = ((tamanho_total - recebido) / tamanho_cada_pacote) * tempo_estimado;

            return tempo_restante;
        }

        

        public void Conectar()
        {
            int cabecalho = 12;
            int cada_pacote = 1000 + cabecalho;
            byte[] data = new byte[cada_pacote];
            byte[] total = null;

            #region Referencia do servidor
            IPEndPoint ip = new IPEndPoint(IPAddress.Parse("172.17.69.2"), 9999); //IPAddress.Parse("172.17.68.20")

            Socket server = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);

            //   IPEndPoint sender = new IPEndPoint(IPAddress.Any, 0);
            EndPoint Remote = (EndPoint)ip;
            #endregion

            #region relativo ao arquivo
            //Console.WriteLine("Digite alguma merda...:"); //no lugar dessa merda vai vir um pacote dizendo o tamanho dos dados
            //string welcome = Console.ReadLine();
            //int tamanho = int.Parse(welcome);

            //data = Encoding.ASCII.GetBytes(welcome);
            int receivedDataLength;
            byte[] corpoPacoteDownload = new byte[0];
            byte[] checkSuuuum = new byte[2];
            checkSuuuum[0] = (byte)8;
            checkSuuuum[1] = (byte)1;
            //DEPOIS A GENTE TEM QUE BOTAR AS PORRAS DAS PORTAS ALEM DO NUMERO DE SEQUENCIA DIREITINHO E TAMBEM O CHECKSUM... AJEITAR TB A PORRA DA HORA...
            int numeroDeSequencia = 0;
            PSR pacotePrimeiroAntes = new PSR(1, numeroDeSequencia, 0, 0, 8, checkSuuuum, corpoPacoteDownload);
            server.SendTo(pacotePrimeiroAntes.Pacotao, pacotePrimeiroAntes.Pacotao.Length, SocketFlags.None, ip);  //mandamos o primeiro pacotim...Pacote Oiiiiii eu quero um download

            PSR pacotePrimeiro = new PSR(1, numeroDeSequencia, 0, 0, 11, checkSuuuum, corpoPacoteDownload);
            server.SendTo(pacotePrimeiro.Pacotao, pacotePrimeiro.Pacotao.Length, SocketFlags.None, ip);  //mandamos o primeiro pacotim...Pacote Oiiiiii eu quero um download

            //vamos receber o tamanho da lista de descricao...
            byte[] tamanhoDaDescricaoByte = new byte[cabecalho + 4];
            //Console.WriteLine("ENtrou aqui 1");
            receivedDataLength = server.ReceiveFrom(tamanhoDaDescricaoByte, ref Remote);//N TA PASSANDO POR AQUI BAIBER...
            PSR pacoteTamanhoDaDescricaoRecebido = new PSR(tamanhoDaDescricaoByte);
            //Console.WriteLine("ENtrou aqui 3");
            int tamanhoDaDescInteiro = pacoteTamanhoDaDescricaoRecebido.TamanhoTipo9;

            //precisamos mandar um ack indicando que recebemos o tamanho da descricao...
            byte[] ackzinho = new byte[0];
            PSR pacoteAck = new PSR(1, numeroDeSequencia, 0, 0, 5, checkSuuuum, ackzinho);
            server.SendTo(pacoteAck.Pacotao, pacoteAck.Pacotao.Length, SocketFlags.None, ip);

            //recebendo agora a descricao...
            byte[] listaDaDescricao = new byte[tamanhoDaDescInteiro + 12];
            receivedDataLength = server.ReceiveFrom(listaDaDescricao, ref Remote);
            PSR pacoteDescricao = new PSR(listaDaDescricao);
            //Console.WriteLine("ENtrou aqui 2");

            //NA GUI ELE VAI FALAR QUAL O ARQUIVO ESCOLHEU... MAS AQUI PRA TESTE VO BOTAR QUE O MALDITO ESCOLHEU O PRIMEIRO... (OBS)
            byte[] queroEsse = new byte[cabecalho + 4 + 4 + 4 + pacoteDescricao.NomeDoArquivo[0].Length];  //(OBS) setar esse corpo aqui DEPOIS... para poder escolher o arquivo direitinho...
            PSR pacoteQueroEsse = new PSR(1, numeroDeSequencia, 0, 0, 9, checkSuuuum, queroEsse);
            server.SendTo(pacoteQueroEsse.Pacotao, pacoteQueroEsse.Pacotao.Length, SocketFlags.None, ip);

            total = new byte[pacoteDescricao.TamanhoDeCadaArquivo[0]]; //SETANDO O TAMANHO TOTAL DO ARRAY
            tamanho = pacoteDescricao.TamanhoDeCadaArquivo[0];
            //A PARTIR DAQUI EH PARA RECEBER UM ARQUIVO...

            DateTime delta1 = DateTime.Now; //envio da requisição do primeiro arquivo.
            //server.SendTo(data, data.Length, SocketFlags.None, ip); //data tem a string enviada e eh truncada
            #endregion

            DateTime tempoAgora = DateTime.Now;
            string temp = tempoAgora.ToString();
//            Console.WriteLine("Tempo Inicial = " + temp + ":" + tempoAgora.Millisecond);

            #region Recebe e cria o arquivo na pasta
            data = new byte[cada_pacote]; //realoco espaço pra data
            int i = 0;

            double tempo_estimado = 0;
            double[] arrayRTT = new double[(tamanho / (cada_pacote - 12)) + 1];// é array porque vai precisar gerar o grafico
            double tempo_restante;
            int indice = 0;
            byte[] temporario;
            int loop = (tamanho / (cada_pacote - 12));
            if ((tamanho % (cada_pacote - 12)) != 0) loop = loop + 1;
            do
            {
                //aqui se recebe o arquivo
                receivedDataLength = server.ReceiveFrom(data, ref Remote);


                //saber se o arquivo veio certim... (OBS)
                temporario = new byte[receivedDataLength];
                Array.Copy(data, temporario, receivedDataLength);
                PSR pacoteDados = new PSR(temporario);
                server.SendTo(pacoteAck.Pacotao, pacoteAck.Pacotao.Length, SocketFlags.None, ip);//(OBS) setar o numero de sequencia...
                DateTime delta2 = DateTime.Now; //tempo depois q o arquivo é recebido
                TimeSpan Rtt = delta2.Subtract(delta1); // calculo do rtt
                //                Console.WriteLine("o Rtt do pacote " + i + " eh: " + ((int)Rtt.TotalMilliseconds) + " ms");
                delta1 = DateTime.Now; // tempo antes de mandar o ack q vai liberar o prox pacote


                //byte[] ack = new byte[2];
                //ack[0] = 5;
                //server.SendTo(ack, ack.Length, SocketFlags.None, ip); //"ack" enviado

                arrayRTT[i] = Rtt.TotalMilliseconds;

                tempo_estimado = RttEstimado(tempo_estimado, arrayRTT[i]);
                //                Console.WriteLine("Rtt estimado dos proximos pacotes eh: " + (int)tempo_estimado + " ms");
                tempo_restante = TempoParaAcabar(tamanho, indice, receivedDataLength, tempo_estimado);
                //                Console.WriteLine("tempo restante do download eh: " + (int)tempo_restante + " ms");
                //                Console.WriteLine("----------------------------------------------------");

                pacoteDados.Dados.CopyTo(total, indice);
                indice = indice + pacoteDados.Dados.Length;
                i++;
            } while (i < loop);
            data = new byte[cabecalho];
            receivedDataLength = server.ReceiveFrom(data, ref Remote);


            //saber se o arquivo veio certim... (OBS)
            temporario = new byte[receivedDataLength];
            Array.Copy(data, temporario, receivedDataLength);
            PSR pacotinhoFimDeJogo = new PSR(temporario);
            //temporario.CopyTo(total, indice);
            File.WriteAllBytes(@"H:\RESULTADO.txt", total);
            #endregion

            DateTime tempoAgora2 = DateTime.Now;
            string temp2 = tempoAgora2.ToString();
            //Console.WriteLine("Tempo Final = " + temp2 + ":" + tempoAgora2.Millisecond);
            //Console.WriteLine("Acabouuuuuuuuuuuuuuuuuuuuuuuuuuu");
            server.Close();
        }
        //static void Main(string[] args)
        //{
        //}
    }
}