﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using UPLOADServer.Cliente;


namespace GUICliente
{
    public partial class ComponentArquivos : UserControl
    {
        private int tipo;
        bool pausar;
        bool iniciar;
        bool reiniciar;
        bool stop;
        private string ip;
        public int porta;
        private UdpClientSample upload;
        
        public ComponentArquivos()
        {
            InitializeComponent();
            this.pausar = false;
            this.iniciar = false;
            this.reiniciar = false;
            this.stop = false;
        }

        public UdpClientSample Upload
        {
            get { return upload; }
            set { upload = value; }
        }

       
        public bool Pausar
        {
            get { return this.pausar; }
            set { this.pausar = value; }
        }
        public bool Iniciar
        {
            get { return this.iniciar; }
            set { this.iniciar = value; }
        }
        public bool Reiniciar
        {
            get { return this.reiniciar; }
            set { this.reiniciar = value; }
        }
        public bool Stop
        {
            get { return this.stop; }
            set { this.stop = value; }
        }

        public int Tipo 
        {
            get { return this.tipo; }
            set { this.tipo = value; }
        }
        public String GroupBoxName 
        {
            get { return this.controlBox.Text; }
            set { this.controlBox.Text = value;} 
        }

        public String TempoEstimado
        {
            get { return this.lblNumeroTempo.Text; }
            set { this.lblNumeroTempo.Text = value; }
        }
        
        public String PacotesPerdidos 
        {
            get { return this.lblNumeroPacotesPerdidos.Text; }
            set { this.lblNumeroPacotesPerdidos.Text = value; } 
        }

        public String NomeArquivo
        {
            get { return this.lblNomeDoArquivo.Text; }
            set { this.lblNomeDoArquivo.Text = value; }
        }
        public String IP
        {
            get { return this.ip; }
            set { this.ip = value; }
        }
        public int Porta
        {
            get { return this.porta; }
            set { this.porta = value; }
        }
        private void btnIniciar_Click(object sender, EventArgs e)
        {
            if (upload != null)
            {
                this.iniciar = true;
                this.pausar = false;
                this.reiniciar = false;
                this.stop = false;
                string diretorio = @"C:\JuninhoTest\Arquivo.txt";
                //upload.Mandar(diretorio,);
            }
            
        }

        private void btnPausar_Click(object sender, EventArgs e)
        {
            if (upload != null)
            {
                this.pausar = true;
                this.iniciar = false;
                this.reiniciar = false;
                this.stop = false;  
            }
            
        }

        private void btnReiniciar_Click(object sender, EventArgs e)
        {
            if (upload != null)
            {
                this.reiniciar = true;
                this.pausar = false;
                this.iniciar = false;
                this.stop = false;
            }
            
        }

        private void btnParar_Click(object sender, EventArgs e)
        {
            if (upload != null)
            {
                this.stop = true;
                this.pausar = false;
                this.iniciar = false;
                this.reiniciar = false;
            }
            
        }

        
    }
}
