﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Cliente;
using System.Threading;



namespace GUICliente
{
    public partial class FormClient : Form
    {
        int contadorUpload = 0;
        string ip = string.Empty;
        int porta;
        bool conectado = false;
        ClienteUpload cliente;
        DownClient downClient;
        String nomeDoArquivoUpload = "Nadinha";
        String nomeDoArquivoUploadBonitinho = "Nadinha";
        public FormClient()
        {
            InitializeComponent();
            
            //Nome dos arquivos...
            lblNomeDoArquivoUpload.Text = "";
            lblLabelDownload.Text = "";

            //Numero de pacotes perdidos...
            lblNumeroPacotesPerdidosUpload.Text = "";
            lblPacotesPerdidosDownload.Text = "";

            //Tempo estimado de cada pacote...
            lblTempoEstimadoDownload.Text = "";
            lblTempoEstimadoUpload.Text = "";
        }
        #region EVENTOS DOS BOTÕES
        private void btnDownload_Click(object sender, EventArgs e)
        {
            downClient = new DownClient();
            downClient.Conectar();
        }

        private void btnGerarGraficoDownload_Click(object sender, EventArgs e)
        {

        }

        private void btnUpload_Click(object sender, EventArgs e)
        {
            if (contadorUpload == 0)
            {
                this.openFileDialog.ShowDialog();
                 nomeDoArquivoUploadBonitinho = this.openFileDialog.SafeFileName;// SO MANDA O NOME DO ARQUIVO E O FORMATO...
                 nomeDoArquivoUpload = this.openFileDialog.FileName;
                 
                
                string pastaDoArquivo = this.openFileDialog.DefaultExt;
                if (conectado == true)
                {
                    progressBarUpload.Minimum = 0;
                    progressBarUpload.Maximum = 100;
                    progressBarUpload.Step = 1;
                    lblNomeDoArquivoUpload.Text = nomeDoArquivoUploadBonitinho;
                    cliente = new ClienteUpload(nomeDoArquivoUploadBonitinho,this.txbIP.Text,nomeDoArquivoUpload);
                    contadorUpload++;
                    MessageBox.Show("Aperte o PLAY para começar o UPLOAD...", "Aviso!", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    MessageBox.Show("Infelizmente você não está conectado...");
                }

            }
            else
            {
                MessageBox.Show("Amiguinho... voce ja esta fazendo upload, espere acabar...", "Ow mula espera ai...", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void btnGerarGraficoUpload_Click(object sender, EventArgs e)
        {
            double[] arrayTempo = cliente.getArrayTempo();
            
        }

        private void btnOff_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Você desconectou o servidor...");
            this.btnOn.Enabled = false;
            conectado = false;
        }

        private void btnOn_Click(object sender, EventArgs e)
        {
            ip = txbIP.Text;
            porta = Int32.Parse(txbPorta.Text);
            this.btnOn.Enabled = true;
            conectado = true;
        }

        private void groupBox2_Enter(object sender, EventArgs e)
        {

        }

        private void btnPlayDownload_Click(object sender, EventArgs e)
        {

        }

        private void btnPauseDownload_Click(object sender, EventArgs e)
        {

        }

        private void btnReiniciarDownload_Click(object sender, EventArgs e)
        {
            
        }

        private void btnStopDownload_Click(object sender, EventArgs e)
        {

        }

        private void btnPlayUpload_Click(object sender, EventArgs e)
        {
            Thread conectar = new Thread(cliente.Conectar);
            //cliente.Conectar();
            conectar.Start();


            
            //Thread daProg = new Thread(cliente.
            //int t = cliente.getQuantidadeDePacotes();
            //Thread para o progressBar
            //for (int i = 0; i < 50; i++)
            //{
            //    progressBarUpload.PerformStep();    
            //}
            
        }
        

        private void btnPausarUpload_Click(object sender, EventArgs e)
        {

        }

        private void btnReiniciarUpload_Click(object sender, EventArgs e)
        {

        }

        private void btnStopUpload_Click(object sender, EventArgs e)
        {

        }
#endregion
    }
}
