﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ProtocoloSeguroERapidinho;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using Servidor;

namespace ConexaoServidor
{
    class ServidorConexao
    {
        static void Main(string[] args)
        {
            IPEndPoint ip = new IPEndPoint(IPAddress.Any, 9999);

            Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);

            socket.Bind(ip);

            IPEndPoint sender = new IPEndPoint(IPAddress.Any, 0);
            EndPoint Remote = (EndPoint)(ip);

            int cada_pacote = 1000;
            byte[] data = new byte[cada_pacote];

            Worker Escuta = new Worker(socket, Remote, data,sender);
            Thread Thread_escuta = new Thread(Escuta.Escutar);
            Thread_escuta.Start();
            String acabar ="" ;
            bool parar = false;
            while (!parar) 
            {
                acabar = Console.ReadLine();
                parar = true;
            }
        }
    }

    public class Worker
    {
        int receivedDataLength;
        Socket socket;
        EndPoint Remote;
        IPEndPoint sender;
        byte[] data;

        bool thread_criada = false; // se a thread ja foi criada ( pra criar somente 4 no loop infinito do main)

        Thread[] upload;
        Thread[] download;
        int indice = 0;
        byte[] corpoPacoteDownload = new byte[0];
        byte[] checkSuuuum = new byte[2];
        int numeroDeSequencia = 0;

        public Worker(Socket socket, EndPoint Remote, byte[] data, IPEndPoint sender)
        {
            this.socket = socket;
            this.Remote = Remote;
            this.data = data;
            this.sender = sender;
            download = new Thread[4];
            upload = new Thread[4];
        }

        public void Escutar()
        {
            thread_criada = true;
            //while (thread_criada)
            //{
                receivedDataLength = socket.ReceiveFrom(data, ref Remote); //espera requisicao do cliente


                PSR gay = new PSR(data);
                //Console.WriteLine("SYN: " + Util.MetodosEmGeral.GetInt(gay.Pacotao[9]));
                Console.WriteLine("Servidor pacote 8");
                if (gay.Bits == 8)
                {
                    if (upload[indice] == null)
                    {
                        upload[indice] = new Thread(DoWorkUp);
                        upload[indice].Start();
                        download[indice] = new Thread(DoWorkDown);
                        //download[indice].Start();
                        indice = (indice + 1) % 4;
                    }
                }
            //}
        }
        public void DoWorkUp()
        {
            //thread_criada = true;
            Console.WriteLine("Servidor UPLOAD CRIADO 1");
            ServidorUpload upload = new ServidorUpload(this.socket, this.sender, Remote);
            upload.Enviar();
            Console.WriteLine("Servidor UPLOAD CRIADO 2");
        }


        public void DoWorkDown()
        {
            //thread_criada = true;
            Console.WriteLine("Servidor DOWNLOAD CRIADO 1");
            DownServ download = new DownServ();
            download.Enviar();
            Console.WriteLine("Servidor DOWNLOAD CRIADO 2");
               
            //set_retorna_thread_criada(false); //encerra conexao

        }
        
        public void set_retorna_thread_criada(bool setar)
        {
            this.thread_criada = setar;
        }

        public bool retorna_thread_criada()
        {
            return thread_criada;
        }
    }
}
